"use strict";

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

// see: http://bluebirdjs.com/docs/api/deferred-migration.html
function defer() {
  var resolve = function resolve() {};
  var reject = function reject() {};
  var promise = new Promise(function (res, rej) {
    resolve = res;
    reject = rej;
  });
  return {
    resolve: resolve,
    reject: reject,
    promise: promise
  };
}

var PromisePool = function () {
  function PromisePool() {
    var _this = this;

    var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

    _classCallCheck(this, PromisePool);

    this.queue = [];
    this.pool = [];
    this.results = [];
    this.concurrency = Number.MAX_VALUE;
    this.next = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee2() {
      var promiseProducer, run;
      return regeneratorRuntime.wrap(function _callee2$(_context2) {
        while (1) {
          switch (_context2.prev = _context2.next) {
            case 0:
              if (!_this.error) {
                _context2.next = 2;
                break;
              }

              throw _this.error;

            case 2:
              if (!(!_this.queue.length && !_this.pool.length)) {
                _context2.next = 4;
                break;
              }

              return _context2.abrupt("return", _this.results);

            case 4:
              if (!(_this.pool.length >= _this.concurrency || !_this.queue.length)) {
                _context2.next = 9;
                break;
              }

              if (!_this.wait) _this.wait = defer();
              _context2.next = 8;
              return _this.wait.promise;

            case 8:
              return _context2.abrupt("return", _this.next());

            case 9:

              // At this point we have a new promise to run and the concurrency to run it
              promiseProducer = _this.queue.shift();

              run = function () {
                var _ref2 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee() {
                  var promise, result, wait;
                  return regeneratorRuntime.wrap(function _callee$(_context) {
                    while (1) {
                      switch (_context.prev = _context.next) {
                        case 0:
                          promise = promiseProducer();

                          _this.pool.push(promise);
                          result = void 0;
                          _context.prev = 3;
                          _context.next = 6;
                          return promise;

                        case 6:
                          result = _context.sent;
                          _context.next = 12;
                          break;

                        case 9:
                          _context.prev = 9;
                          _context.t0 = _context["catch"](3);

                          _this.error = _context.t0;

                        case 12:

                          _this.results.push(result);
                          _this.pool = _this.pool.filter(function (p) {
                            return p !== promise;
                          });

                          // every time a promise in the queue is resolved then we need to check if
                          // there is anything waiting to be started.

                          if (!_this.wait) {
                            _context.next = 18;
                            break;
                          }

                          wait = _this.wait;

                          _this.wait = undefined;
                          return _context.abrupt("return", wait.resolve());

                        case 18:
                        case "end":
                          return _context.stop();
                      }
                    }
                  }, _callee, _this, [[3, 9]]);
                }));

                return function run() {
                  return _ref2.apply(this, arguments);
                };
              }();

              // run is not awaited otherwise concurrency would never be more than one


              run();
              return _context2.abrupt("return", _this.next());

            case 13:
            case "end":
              return _context2.stop();
          }
        }
      }, _callee2, _this);
    }));

    if (options.concurrency) {
      this.concurrency = options.concurrency;
    }
  }

  _createClass(PromisePool, [{
    key: "add",
    value: function add(promiseProducer) {
      this.queue.push(promiseProducer);
      this.next();
    }
  }, {
    key: "all",
    value: function all() {
      return this.next();
    }
  }]);

  return PromisePool;
}();

module.exports = PromisePool;